function [mll,Rhat] = osc_ll(y,param,init_f)
    T = length(y);
    K = length(param)/3;
    param(K+1:2*K) = init_f+tanh(param(K+1:2*K))*pi;
    F = zeros(2*K,2*K);
    Q = zeros(2*K,2*K);
    for i=1:K
        F(2*i-1:2*i,2*i-1:2*i) = (tanh(param(i))+1)/2*[cos(param(K+i)) -sin(param(K+i)); sin(param(K+i)) cos(param(K+i))];
        Q(2*i-1:2*i,2*i-1:2*i) = exp(param(2*K+i))*eye(2);
    end
    H = zeros(1,2*K);
    H(1:2:2*K) = 1;
    R = 1;

    x_pred1 = zeros(2*K,T);
    x_filt = zeros(2*K,T);
    V_pred1 = zeros(2*K,2*K,T);
    V_filt = zeros(2*K,2*K,T);
    x_pred1(:,1) = zeros(2*K,1);
    for i=1:K
        V_pred1(2*i-1:2*i,2*i-1:2*i,1) = Q(2*i-1:2*i,2*i-1:2*i)/(1-F(2*i-1,2*i-1)^2-F(2*i-1,2*i)^2);
    end
    for t=1:T-1
        x_filt(:,t) = x_pred1(:,t) + V_pred1(:,:,t)*H'*((H*V_pred1(:,:,t)*H'+R)\(y(t)-H*x_pred1(:,t)));
        V_filt(:,:,t) = V_pred1(:,:,t) - V_pred1(:,:,t)*H'*((H*V_pred1(:,:,t)*H'+R)\H)*V_pred1(:,:,t);
        x_pred1(:,t+1) = F*x_filt(:,t);
        V_pred1(:,:,t+1) = F*V_filt(:,:,t)*F'+Q;
    end
    Rhat = 0;
    for t=1:T
        Rhat = Rhat*(t-1)/t+(y(t)-H*x_pred1(:,t))^2/(H*V_pred1(:,:,t)*H'+R)/t;
    end
    ll = -T*log(Rhat)/2-T/2;
    for t=1:T
        ll = ll-log(H*V_pred1(:,:,t)*H'+R)/2;
    end
    mll = -ll;
end

