function []=plot_osc_decomp(y,fs,decomp_mu,decomp_cov,K)
    T = length(y);
    T1 = 1;
    T2 = T;
    Tstart = 0;
    figure;
    subplot(K+2,1,1),plot(Tstart+(T1:T2)/fs,y(T1:T2),'b-'),xlim(Tstart+[T1 T2]/fs);
    set(gca,'FontSize',12);
    comp_sum = zeros(1,T2-T1+1);
    for i=1:K
        subplot(K+2,1,i+1);
        hold on
        std_bar = reshape(sqrt(decomp_cov(2*i-1,2*i-1,T1:T2,K)),1,T2-T1+1);
        xx = [Tstart+(T1:T2)/fs Tstart+(T2:-1:T1)/fs]';
        yy = [decomp_mu(2*i-1,T1:T2,K)-std_bar decomp_mu(2*i-1,T2:-1:T1,K)+std_bar(T2-T1+1:-1:1)]';
        fill(xx,yy,[.8,.8,.8],'EdgeColor','none');
        plot(Tstart+(T1:T2)/fs,decomp_mu(2*i-1,T1:T2,K),'r-');
        xlim(Tstart+[T1 T2]/fs);
        set(gca,'FontSize',12);
        comp_sum = comp_sum+decomp_mu(2*i-1,T1:T2,K);
    end
    subplot(K+2,1,K+2),plot(Tstart+(T1:T2)/fs,y(T1:T2)-comp_sum),xlim(Tstart+[T1 T2]/fs);
    set(gca,'FontSize',12);
end
