function []=plot_osc_phase(fs,phase,decomp_mu,decomp_cov,K)
    nmc = 10^4;
    T = size(phase,2);
    T1 = 1;
    T2 = T;
    Tstart = 0;
    phase1 = zeros(1,T2-T1+1);
    phase2 = zeros(1,T2-T1+1);
    seeds = randn(2,nmc);
    figure;
    for k=1:K
        for t=T1:T2
            tmp = angle_conf_MC(decomp_mu(2*k-1:2*k,t,K),decomp_cov(2*k-1:2*k,2*k-1:2*k,t,K),2*normcdf(1)-1,seeds);
            phase1(t-T1+1) = tmp(1);
            phase2(t-T1+1) = tmp(2);
        end
        subplot(K,1,k)
        hold on
        plot_phase_area(Tstart+(T1:T2)/fs,phase(k,T1:T2,K),phase1,phase2,[.8,.8,.8]);
        plot_phase_nocross(Tstart+(T1:T2)/fs,phase(k,T1:T2,K),'b-',2);
        xlim(Tstart+[T1 T2]/fs);
        set(gca,'FontSize',12);
        ax = gca;
        set(ax,'YTick',[-pi 0 pi]);
        set(ax,'YTickLabel',{'-3.14', '0', '3.14'});
    end
end
